<?php

namespace App\Http\Controllers;

use App\Models\ApiModel;

class CadastrarInscricaoController {

    public function __construct() {
        
    }

    public function index() {
        return view('CadastrarInscricaoView');
    }

    public function cadastrarInscricao() {
        
        $dados = [
            "cep" => $_POST['cep'],
            "tipo" => $_POST['tipo'],
            "codigo" => 0,
            "numero" => $_POST['numero'],
            "memorial" => $_POST['memorial'],
            "englobado" => $_POST['englobado'],
            "complemento" => $_POST['complemento'],
            "dataInclusao" => str_replace("T", " ", $_POST['dataInclusao']).':00',
            "dataExclusao" => str_replace("T", " ", $_POST['dataExclusao']).':00',
            "dataAlteracao" => str_replace("T", " ", $_POST['dataAlteracao']).':00',
            "exclusaoLogica" => $_POST['exclusaoLogica'],
            "processoInclusao" => $_POST['processoInclusao'],
            "processoExclusao" => $_POST['processoExclusao'],
            "correspondenciaLocal" => $_POST['correspondenciaLocal'],
            "pessoa" => [
                "id" => $_POST['pessoa']['id'],
                "nome" => $_POST['pessoa']['nome'],
                "tipo" => $_POST['pessoa']['tipo'],
                "fantasia" => $_POST['pessoa']['fantasia'],
                "documento" => $_POST['pessoa']['documento'],
                "inscricaoEstadual" => $_POST['pessoa']['inscricaoEstadual']
            ],
            "logradouro" => [
                "nome" => $_POST['logradouro']['nome'],
                "tipo" => [
                    "id" => $_POST['logradouro']['tipo']['id'],
                    "sigla" => $_POST['logradouro']['tipo']['sigla'],
                    "descricao" => $_POST['logradouro']['tipo']['descricao']
                ],
                "codigo" => $_POST['logradouro']['codigo']
            ],
            "bairro" => [
                "nome" => $_POST['bairro']['nome'],
                "codigo" => $_POST['bairro']['codigo']
            ],
            "cidade" => [
                "tipo" => [
                    "sigla" => $_POST['cidade']['tipo']['sigla'],
                    "descricao" => $_POST['cidade']['tipo']['descricao']
                ],
                "nome" => $_POST['cidade']['nome'],
                "codigoIbge" => $_POST['cidade']['codigoIbge']
            ],
            "proprietarios" => [],
            "imobiliario" => [
                "lote" => $_POST['imobiliario']['lote'],
                "face" => $_POST['imobiliario']['face'],
                "setor" => $_POST['imobiliario']['setor'],
                "quadra" => $_POST['imobiliario']['quadra'],
                "unidade" => $_POST['imobiliario']['unidade'],
                "distrito" => $_POST['imobiliario']['distrito'],
                "matricula" => $_POST['imobiliario']['matricula'],
                "edificacao" => $_POST['imobiliario']['edificacao'],
                "loteFiscal" => $_POST['imobiliario']['loteFiscal'],
                "quadraFiscal" => $_POST['imobiliario']['quadraFiscal'],
                "complementoLote" => $_POST['imobiliario']['complementoLote'],
                "tipoLote" => "Loteamento",
                "blocoFiscal" => $_POST['imobiliario']['blocoFiscal'],
                "apartamentoFiscal" => $_POST['imobiliario']['apartamentoFiscal'],
                "salaBlocoFiscal" => $_POST['imobiliario']['salaBlocoFiscal'],
                "unidadeFiscal" => $_POST['imobiliario']['unidadeFiscal'],
                "profundidades" => [],
                "inscricaoCadastral" => $_POST['imobiliario']['matricula'],
                "testadas" => [[
                    "campo" => 0,
                    "secao" => [
                        "id" => ""
                    ],
                    "numero" => 0,
                    "tamanho" => 0,
                    "principal" => ""
                ]],
                "situacao" => [
                    "id" => "C",
                    "descricao" => "Ativo",
                    "motivo" => ""
                ],
                "segmentos" => [
                    "id" => "",
                    "codigo" => "" 
                ],
                "solicitacaoInscricao" => [
                    "id" => "N",
                    "descricao" => "NENHUM"
                ],
                "boletim" => []
            ],
            "correspondencia" => "",
            "inscricoesAnteriores" => []
        ];
        
        $retorno = ApiModel::cadastrarInscricao($dados);
        return response()->json($retorno ?? '');
    }

    public function verificarPessoa() {
        $pessoa = ApiModel::consultarPessoa($_POST['documento']);
        return response()->json($pessoa[0] ?? '');
    }

    public function consultarLogradouro() {
        $logradouro = ApiModel::consultarLogradouro($_POST['logra']);
        return response()->json($logradouro[0] ?? '');
    }

    public function consultarBairro() {
        $bairro = ApiModel::consultarBairro($_POST['bairro']);
        return response()->json($bairro[0] ?? '');
    }

    public function consultarCidade() {
        $cidade = ApiModel::consultarCidade($_POST['cidade']);
        return response()->json($cidade[0] ?? '');
    }

}
