<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class ApiModel extends Model {

    public static function autenticar() {

        $url = 'https://gpi02.cloud.el.com.br/ServerExec/tributario/tributarioclient/auth';
        $data = [
            'usuario' => 'PM_BA_JEQUIE',
            'senha' => '8e39d3b8-500a'
        ];

        $jsonData = json_encode($data);

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $jsonData);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, ['Content-Type: application/json']);
        curl_setopt($ch, CURLOPT_TIMEOUT, 10);  // Timeout de 10 segundos

        $response = curl_exec($ch);

        if (curl_errno($ch)) {
            ApiModel::logMessage('Erro ao obter token: ' . curl_error($ch));
            curl_close($ch);
            return false;
        }

        curl_close($ch);

        $responseData = json_decode($response, true);

        if (json_last_error() !== JSON_ERROR_NONE || !isset($responseData['token'])) {
            ApiModel::logMessage('Erro ao decodificar resposta do token: ' . json_last_error_msg());
            return false;
        }

        return $responseData['token'];
    }

    public static function consultarInscricao($inscricao) {

        $url = 'https://gpi02.cloud.el.com.br/ServerExec/tributario/tributarioclient/bci/ac/consulta/inscricao';
        $data = [
            'inscricao_municipal' => $inscricao
        ];

        $authorization = "Authorization: Bearer " . ApiModel::autenticar();

        $jsonData = json_encode($data);

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $jsonData);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, ['Content-Type: application/json', $authorization]);
        curl_setopt($ch, CURLOPT_TIMEOUT, 10);  // Timeout de 10 segundos

        $response = curl_exec($ch);

        if (curl_errno($ch)) {
            ApiModel::logMessage('Erro: ' . curl_error($ch));
            curl_close($ch);
            return false;
        }

        curl_close($ch);

        $responseData = json_decode($response, true);

        return $responseData;
    }

    public static function consultarPessoa($documento) {

        $url = 'https://gpi02.cloud.el.com.br/ServerExec/tributario/tributarioclient/bci/ac/consulta/pessoa';
        $data = [
            'documento' => $documento
        ];

        $authorization = "Authorization: Bearer " . ApiModel::autenticar();

        $jsonData = json_encode($data);

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $jsonData);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, ['Content-Type: application/json', $authorization]);
        curl_setopt($ch, CURLOPT_TIMEOUT, 10);  // Timeout de 10 segundos

        $response = curl_exec($ch);

        if (curl_errno($ch)) {
            ApiModel::logMessage('Erro: ' . curl_error($ch));
            curl_close($ch);
            return false;
        }

        curl_close($ch);

        $responseData = json_decode($response, true);

        return $responseData;
    }

    public static function consultarLogradouro($logra) {

        $url = 'https://gpi02.cloud.el.com.br/ServerExec/tributario/tributarioclient/bci/ac/consulta/logradouro';
        $data = [
            'nome' => $logra
        ];

        $authorization = "Authorization: Bearer " . ApiModel::autenticar();

        $jsonData = json_encode($data);

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $jsonData);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, ['Content-Type: application/json', $authorization]);
        curl_setopt($ch, CURLOPT_TIMEOUT, 10);  // Timeout de 10 segundos

        $response = curl_exec($ch);

        if (curl_errno($ch)) {
            ApiModel::logMessage('Erro: ' . curl_error($ch));
            curl_close($ch);
            return false;
        }

        curl_close($ch);

        $responseData = json_decode($response, true);

        return $responseData;
    }

    public static function consultarBairro($bairro) {

        $url = 'https://gpi02.cloud.el.com.br/ServerExec/tributario/tributarioclient/bci/ac/consulta/bairro';
        $data = [
            'nome' => $bairro
        ];

        $authorization = "Authorization: Bearer " . ApiModel::autenticar();

        $jsonData = json_encode($data);

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $jsonData);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, ['Content-Type: application/json', $authorization]);
        curl_setopt($ch, CURLOPT_TIMEOUT, 10);  // Timeout de 10 segundos

        $response = curl_exec($ch);

        if (curl_errno($ch)) {
            ApiModel::logMessage('Erro: ' . curl_error($ch));
            curl_close($ch);
            return false;
        }

        curl_close($ch);

        $responseData = json_decode($response, true);

        return $responseData;
    }

    public static function consultarCidade($cidade) {

        $url = 'https://gpi02.cloud.el.com.br/ServerExec/tributario/tributarioclient/bci/ac/consulta/cidade';
        $data = [
            'nome' => $cidade
        ];

        $authorization = "Authorization: Bearer " . ApiModel::autenticar();

        $jsonData = json_encode($data);

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $jsonData);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, ['Content-Type: application/json', $authorization]);
        curl_setopt($ch, CURLOPT_TIMEOUT, 10);  // Timeout de 10 segundos

        $response = curl_exec($ch);

        if (curl_errno($ch)) {
            ApiModel::logMessage('Erro: ' . curl_error($ch));
            curl_close($ch);
            return false;
        }

        curl_close($ch);

        $responseData = json_decode($response, true);

        return $responseData;
    }

    public static function cadastrarInscricao($dados) {

        $url = 'https://gpi02.cloud.el.com.br/ServerExec/tributario/tributarioclient/bci/ac/cadastro';

        $authorization = "Authorization: Bearer " . ApiModel::autenticar();

        $jsonData = json_encode($dados);

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $jsonData);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, ['Content-Type: application/json', $authorization]);
        curl_setopt($ch, CURLOPT_TIMEOUT, 10);  // Timeout de 10 segundos

        $response = curl_exec($ch);
        
        if (curl_errno($ch)) {
            ApiModel::logMessage('Erro: ' . curl_error($ch));
            curl_close($ch);
            return false;
        }

        curl_close($ch);

        $responseData = json_decode($response, true);

        return $responseData;
    }

    public static function logMessage($param) {
        try {
            
        } catch (Exception $exc) {
            return $exc->getTraceAsString();
        }
    }
 
}
