<!DOCTYPE html>
<html lang="pt-BR">
    <head>
        <meta charset="UTF-8">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <title>Cadastrar Nova Inscrição</title>
        <link href="https://cdn.jsdelivr.net/npm/bootstrap-dark-5@1/dist/css/bootstrap-dark.min.css" rel="stylesheet" />
        <script src="https://code.jquery.com/jquery-3.6.0.min.js"></script>        
        <style>
            body {
                font-family: Arial, sans-serif;
                background-color: #f4f4f9;
                margin: 0;
                padding: 20px;
            }

            h1, h2 {
                color: #333;
            }

            form {
                max-width: 800px;
                margin: 0 auto;
                background: #fff;
                padding: 20px;
                border-radius: 8px;
                box-shadow: 0 2px 4px rgba(0, 0, 0, 0.1);
            }

            label {
                font-weight: bold;
                margin-top: 10px;
                display: block;
            }

            input[type="text"], input[type="number"], input[type="datetime-local"] {
                width: 100%;
                padding: 8px;
                margin: 5px 0 15px;
                border: 1px solid #ccc;
                border-radius: 4px;
                font-size: 14px;
            }

            input[type="submit"] {
                background-color: #007BFF;
                color: #fff;
                border: none;
                padding: 10px 15px;
                border-radius: 5px;
                cursor: pointer;
                font-size: 16px;
            }

            input[type="submit"]:hover {
                background-color: #0056b3;
            }

            .section {
                margin-bottom: 20px;
            }

            .section h2 {
                border-bottom: 2px solid #ddd;
                padding-bottom: 5px;
            }

            .form-grid {
                display: grid;
                grid-template-columns: 1fr 1fr;
                gap: 10px;
            }

            .form-grid input {
                width: calc(100% - 10px);
            }

            /* highlightTyped use mark */
            .autocomplete-menu mark {
                text-decoration: underline;
                background: none;
                color: currentColor;
                padding: 0;
            }

            /* Optional nicer scrollbars */
            .autocomplete-menu {
                --scroller-color: 0, 0%;
                --scroller-color-lightness: 80%;
                --scroller-bg-lightness: 90%;
                --scroller-hover-factor: 0.8;
                --scroller-thumb: hsl(var(--scroller-color), var(--scroller-color-lightness));
                /* Replicate hover for webkit */
                --scroller-thumb-hover: hsl(var(--scroller-color), calc(var(--scroller-color-lightness) * var(--scroller-hover-factor)));
                --scroller-background: hsl(var(--scroller-color), calc(var(--scroller-bg-lightness)));
                scrollbar-color: var(--scroller-thumb) var(--scroller-background);
                scrollbar-width: thin;
            }

            .autocomplete-menu::-webkit-scrollbar {
                width: 8px;
            }

            .autocomplete-menu::-webkit-scrollbar-track {
                background: var(--scroller-background);
            }

            .autocomplete-menu::-webkit-scrollbar-thumb {
                background: var(--scroller-thumb);
            }

            .autocomplete-menu::-webkit-scrollbar-thumb:hover {
                background: var(--scroller-thumb-hover);
            }
        </style>        
    </head>
    <body>
        <?php include 'IndexView.php'; ?>
        <div align="center"><h1>Cadastrar Nova Inscrição</h1></div>
        <form action="cadastrar_inscricao.php" method="post" id="dados_inscricao" name="dados_inscricao">

            <div class="section">
                <h2>Endereço</h2>
                <div class="form-grid">
                    <div>
                        <label for="cep">CEP:</label>
                        <input type="text" id="cep" name="cep">
                    </div>
                    
                   
                    <div>
                        <label for="numero">Número:</label>
                        <input type="text" id="numero" name="numero">
                    </div>
                    
                    
                    <div>
                        <label for="complemento">Complemento:</label>
                        <input type="text" id="complemento" name="complemento">
                    </div>
                    <div>
                        <label for="dataInclusao">Data de Inclusão:</label>
                        <input type="datetime-local" id="dataInclusao" name="dataInclusao">
                    </div>
                    
                   
                    
                    
                    
                    
                    <div>
                        <label for="logradouroInscricao">Logradouro:</label>
                        <input class="form-control" type="text" id="logradouroInscricao" name="logradouro[nome]" onblur="consultarLogradouro()">
                        <input type="hidden" id="tipoIdLogradouro" name="logradouro[tipo][id]"/>
                        <input type="hidden" id="tipoSiglaLogradouro" name="logradouro[tipo][sigla]"/>
                        <input type="hidden" id="tipoDescricao" name="logradouro[tipo][descricao]"/>
                        <input type="hidden" id="idLogradouro" name="logradouro[codigo]"/>
                    </div>
                    <div>
                        <label for="bairroInscricao">Bairro:</label>
                        <input class="form-control" type="text" id="bairroInscricao" name="bairro[nome]" onblur="consultarBairro()">
                        <input type="hidden" id="idBairro" name="bairro[codigo]"/>
                    </div>
                    <div>
                        <label for="cidadeInscricao">Cidade:</label>
                        <input class="form-control" type="text" id="cidadeInscricao" name="cidade[nome]" onblur="consultarCidade()">
                        <input type="hidden" id="idCidade" name="cidade[codigoIbge]"/>
                        <input type="hidden" id="tipoSiglaCidade" name="cidade[tipo][sigla]"/>
                        <input type="hidden" id="tipoDescricaoCidade" name="cidade[tipo][descricao]"/>
                    </div>
                </div>
            </div>

            <div class="section">
                <h2>Dados da Pessoa</h2>
                <label for="pessoa_documento">Documento:</label>
                <input type="text" id="pessoa_documento" name="pessoa[documento]" onblur="verificaPessoa(this.value);">
                <span id="status"></span>                

                <label for="pessoa_nome">Nome:</label>
                <input type="text" id="pessoa_nome" name="pessoa[nome]">            

                <label for="pessoa_inscricaoEstadual">Inscrição Estadual:</label>
                <input type="text" id="pessoa_inscricaoEstadual" name="pessoa[inscricaoEstadual]">

                <label for="pessoa_endereco">Endereço:</label>
                <input type="text" id="pessoa_endereco" name="pessoa_endereco">

                <input type="hidden" id="idPessoa" name="pessoa[id]"/>
                <input type="hidden" id="tipoPessoa" name="pessoa[tipo]"/>
                <input type="hidden" id="nomeFantasiaPessoa" name="pessoa[fantasia]"/>
            </div>

            <div class="section">
                <h2>Imobiliário</h2>
                <div class="form-grid">
                    <div>
                        <label for="lote">Lote:</label>
                        <input type="text" id="lote" name="imobiliario[lote]" oninput="atualizarInscricao()">
                    </div>
                    <div>
                        <label for="face">Face:</label>
                        <input type="text" id="face" name="imobiliario[face]" oninput="atualizarInscricao()">
                    </div>
                    <div>
                        <label for="setor">Setor:</label>
                        <input type="text" id="setor" name="imobiliario[setor]" oninput="atualizarInscricao()">
                    </div>
                    <div>
                        <label for="quadra">Quadra:</label>
                        <input type="text" id="quadra" name="imobiliario[quadra]" oninput="atualizarInscricao()">
                    </div>
                    <div>
                        <label for="unidade">Unidade:</label>
                        <input type="text" id="unidade" name="imobiliario[unidade]" oninput="atualizarInscricao()">
                    </div>
                    <div>
                        <label for="distrito">Distrito:</label>
                        <input type="text" id="distrito" name="imobiliario[distrito]" oninput="atualizarInscricao()">
                    </div>
                    <div>
                        <label for="matricula">Matrícula:</label>
                        <input type="text" id="matricula" name="imobiliario[matricula]" oninput="atualizarInscricao()">
                    </div>
                    <div>
                        <label for="edificacao">Edificação:</label>
                        <input type="text" id="edificacao" name="imobiliario[edificacao]" oninput="atualizarInscricao()">
                    </div>
                    <div>
                        <label for="loteFiscal">Lote Fiscal:</label>
                        <input type="text" id="loteFiscal" name="imobiliario[loteFiscal]" oninput="atualizarInscricao()">
                    </div>
                    <div>
                        <label for="quadraFiscal">Quadra Fiscal:</label>
                        <input type="text" id="quadraFiscal" name="imobiliario[quadraFiscal]" oninput="atualizarInscricao()">
                    </div>
                    <div>
                        <label for="complementoLote">Complemento Lote:</label>
                        <input type="text" id="complementoLote" name="imobiliario[complementoLote]" oninput="atualizarInscricao()">
                    </div>
                    <div>
                        <label for="tipoLote">Tipo Lote:</label>
                        <input type="text" id="tipoLote" name="imobiliario[tipoLote]" oninput="atualizarInscricao()">
                    </div>
                    <div>
                        <label for="blocoFiscal">Bloclo Fiscal:</label>
                        <input type="text" id="blocoFiscal" name="imobiliario[blocoFiscal]" oninput="atualizarInscricao()">
                    </div>
                    <div>
                        <label for="apartamentoFiscal">Apartamento Fiscal:</label>
                        <input type="text" id="apartamentoFiscal" name="imobiliario[apartamentoFiscal]" oninput="atualizarInscricao()">
                    </div>
                    <div>
                        <label for="salaBlocoFiscal">Sala Bloco Fiscal:</label>
                        <input type="text" id="salaBlocoFiscal" name="imobiliario[salaBlocoFiscal]" oninput="atualizarInscricao()">
                    </div>
                    <div>
                        <label for="unidadeFiscal">Unidade Fiscal:</label>
                        <input type="text" id="unidadeFiscal" name="imobiliario[unidadeFiscal]" oninput="atualizarInscricao()">
                    </div>
                    <div>
                        <label for="inscricaoCadastral">Inscrição Cadastral:</label>
                        <input type="text" id="inscricaoCadastral" name="imobiliario[inscricaoCadastral]" readonly>
                    </div>
                </div>
            </div>

            <script>
                function atualizarInscricao() {
                    const distrito = document.getElementById("distrito").value.padStart(2, '0');
                    const setor = document.getElementById("setor").value.padStart(2, '0');
                    const quadra = document.getElementById("quadra").value.padStart(4, '0');
                    const lote = document.getElementById("lote").value.padStart(4, '0');
                    const unidade = document.getElementById("unidade").value.padStart(2, '0');

                    const inscricao = `${distrito}${setor}${quadra}${lote}${unidade}`;
                    document.getElementById("inscricaoCadastral").value = inscricao;
                }

                function verificaPessoa() {
                    var documento = document.getElementById('pessoa_documento').value;

                    // Fazendo uma requisição AJAX para o backend Lumen
                    $.ajax({
                        url: '/cadastrar/verificar-pessoa', // A URL da sua rota no Lumen
                        type: 'POST',
                        data: {documento: documento},
                        success: function (response) {
                            // Manipule a resposta aqui
                            if (response == '' && documento != '') {
                                document.getElementById('status').style.display = 'block';
                                document.getElementById('status').innerHTML = 'Pessoa não encontrada';
                                document.getElementById('status').style.color = 'red';

                                $('#pessoa_nome').val("");
                                $('#pessoa_inscricaoEstadual').val("");
                                $('#pessoa_endereco').val("");

                            } else {
                                document.getElementById('status').style.display = 'none';

                                $('#idPessoa').val(response.id);
                                $('#tipoPessoa').val(response.tipo);
                                $('#nomeFantasiaPessoa').val(response.fantasia);
                                $('#pessoa_nome').val(response.nome);
                                $('#pessoa_inscricaoEstadual').val(response.inscricaoEstadual);
                                $('#pessoa_endereco').val(response.endereco.logradouro.tipo.sigla + ' ' +
                                        response.endereco.logradouro.nome + ', ' +
                                        response.endereco.numero + ', ' +
                                        response.endereco.bairro.nome + ', ' +
                                        response.endereco.cidade.nome + ' - ' +
                                        response.endereco.cidade.tipo.sigla + ' CEP: ' +
                                        response.endereco.cep);
                            }
                        },
                        error: function () {
                            document.getElementById('status').innerHTML = 'Erro ao verificar documento.';
                            document.getElementById('status').style.color = 'red';
                        }
                    });
                }

                function cadastrarInscricao() {
                    var dados = $('#dados_inscricao').serialize();

                    // Fazendo uma requisição AJAX para o backend Lumen
                    $.ajax({
                        url: '/cadastrar/cadastrar-inscricao', // A URL da sua rota no Lumen
                        type: 'POST',
                        dataType: 'json',
                        data: dados,
                        success: function (response) {
                            $("#mensagemRetorno").css("display", "block");

                            if (response.erro) {
                                $("#mensagemRetorno").html("Erro ao cadastrar a inscrição, confira os dados digitados e tente novamente\n");
                                $("#mensagemRetorno").append(response.erro);
                                $("#mensagemRetorno").removeClass('alert-success');
                                $("#mensagemRetorno").addClass('alert-danger');
                            } else {
                                $("#mensagemRetorno").html("Inscrição cadastrada com sucesso");
                            }

                            setTimeout(function () {
                                $("#mensagemRetorno").css("display", "none");
                            }, 10000);

                        },
                        error: function () {

                        }
                    });
                }

                function consultarLogradouro() {
                    var logra = document.getElementById('logradouroInscricao').value;
                    // Fazendo uma requisição AJAX para o backend Lumen
                    $.ajax({
                        url: '/cadastrar/consultar-logradouro', // A URL da sua rota no Lumen
                        type: 'POST',
                        data: {logra: logra},
                        success: function (response) {
                            if (response.codigo) {
                                $("#tipoIdLogradouro").val(response.tipo.id);
                                $("#tipoSiglaLogradouro").val(response.tipo.sigla);
                                $("#tipoDescricao").val(response.tipo.descricao);
                                $("#idLogradouro").val(response.codigo);

                                document.getElementById('logradouroInscricao').style.color = 'green';
                            } else {
                                $("#logradouroInscricao").val("");
                                $("#idLogradouro").val("");
                                document.getElementById('logradouroInscricao').style.color = 'black';
                            }
                        },
                        error: function () {

                        }
                    });
                }

                function consultarBairro() {
                    var bairro = document.getElementById('bairroInscricao').value;
                    // Fazendo uma requisição AJAX para o backend Lumen
                    $.ajax({
                        url: '/cadastrar/consultar-bairro', // A URL da sua rota no Lumen
                        type: 'POST',
                        data: {bairro: bairro},
                        success: function (response) {
                            if (response.codigo) {
                                $("#idBairro").val(response.codigo);
                                document.getElementById('bairroInscricao').style.color = 'green';
                            } else {
                                $("#bairroInscricao").val("");
                                $("#idBairro").val("");
                                document.getElementById('bairroInscricao').style.color = 'black';
                            }
                        },
                        error: function () {

                        }
                    });
                }

                function consultarCidade() {
                    var cidade = document.getElementById('cidadeInscricao').value;
                    // Fazendo uma requisição AJAX para o backend Lumen
                    $.ajax({
                        url: '/cadastrar/consultar-cidade', // A URL da sua rota no Lumen
                        type: 'POST',
                        data: {cidade: cidade},
                        success: function (response) {
                            if (response.codigoIbge) {
                                $("#idCidade").val(response.codigoIbge);
                                $("#tipoSiglaCidade").val(response.tipo.sigla);
                                $("#tipoDescricaoCidade").val(response.tipo.descricao);
                                document.getElementById('cidadeInscricao').style.color = 'green';
                            } else {
                                $("#cidadeInscricao").val("");
                                $("#idCidade").val("");
                                document.getElementById('cidadeInscricao').style.color = 'black';
                            }
                        },
                        error: function () {

                        }
                    });
                }
            </script>
            <input type="button" value="Cadastrar" onclick="cadastrarInscricao()">
            <br>
            <br>
            <div class="alert alert-success" role="alert" style="display: none" id="mensagemRetorno"></div>
        </form>
    </body>
</html>
