<!DOCTYPE html>
<html lang="pt-BR">
    <head>
        <meta charset="UTF-8">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <title>Consultar Inscrição</title>
        <style>
            body {
                font-family: Arial, sans-serif;
                background-color: #f4f4f9;
                margin: 0;
                padding: 20px;
            }

            h1, h2 {
                color: #333;
            }

            form {
                max-width: 800px;
                margin: 0 auto;
                background: #fff;
                padding: 20px;
                border-radius: 8px;
                box-shadow: 0 2px 4px rgba(0, 0, 0, 0.1);
            }

            label {
                font-weight: bold;
                margin-top: 10px;
                display: block;
            }

            input[type="text"], input[type="number"], input[type="datetime-local"] {
                width: 100%;
                padding: 8px;
                margin: 5px 0 15px;
                border: 1px solid #ccc;
                border-radius: 4px;
                font-size: 14px;
            }

            input[type="submit"] {
                background-color: #007BFF;
                color: #fff;
                border: none;
                padding: 10px 15px;
                border-radius: 5px;
                cursor: pointer;
                font-size: 16px;
            }

            input[type="submit"]:hover {
                background-color: #0056b3;
            }

            .section {
                margin-bottom: 20px;
            }

            .section h2 {
                border-bottom: 2px solid #ddd;
                padding-bottom: 5px;
            }

            .form-grid {
                display: grid;
                grid-template-columns: 1fr 1fr;
                gap: 10px;
            }

            .form-grid input {
                width: calc(100% - 10px);
            }
        </style>
    </head>
    <body>
        <?php include 'IndexView.php'; ?>
        <div align="center"><h1>Consultar Inscrição</h1></div>
        <form action="/consultar/consultarInscricao" method="post">
            <div class="section">
                <div class="form-grid">
                    <div>
                        <label for="inscricaoCadastral">Inscrição Municipal:</label>
                        <input type="text" id="inscricao" name="inscricao">
                    </div>
                </div>
                <input type="submit" value="Consultar">
            </div>
            <?php
            if (@$dados) {
                echo "<div align=\"center\"><h2>Dados da Inscrição Encontrada</h2></div>";
                dd($dados);
            }
            ?>
        </form>
    </body>
</html>
