<?php

/** @var \Laravel\Lumen\Routing\Router $router */
/*
  |--------------------------------------------------------------------------
  | Application Routes
  |--------------------------------------------------------------------------
  |
  | Here is where you can register all of the routes for an application.
  | It is a breeze. Simply tell Lumen the URIs it should respond to
  | and give it the Closure to call when that URI is requested.
  |
 */
$router->get('/', function () {
    return view('IndexView');
});

$router->group(['prefix' => '/consultar'], function () use ($router) {
    $router->get('/', "ConsultaInscricaoController@index");
    $router->post('/consultarInscricao', "ConsultaInscricaoController@consultarInscricao");
});

$router->group(['prefix' => '/cadastrar'], function () use ($router) {
    $router->get('/', "CadastrarInscricaoController@index");
    $router->post('/cadastrar-inscricao', "CadastrarInscricaoController@cadastrarInscricao");
    $router->post('/verificar-pessoa', "CadastrarInscricaoController@verificarPessoa");
    $router->post('/consultar-logradouro', "CadastrarInscricaoController@consultarLogradouro");
    $router->post('/consultar-bairro', "CadastrarInscricaoController@consultarBairro");
    $router->post('/consultar-cidade', "CadastrarInscricaoController@consultarCidade");
});